#ifndef DDIST_H
#define DDIST_H

#include <string>
#include "ptopk.h"

struct histogram;

class DistDist {
 public:
     virtual double score_ub(Box box1, Box box2) = 0;
     virtual double score_lb(Box box1, Box box2) = 0;
     virtual float pvalue(float distance) = 0;
};

class DistDistHistogram : public DistDist {
public:
     struct histogram *h;
     DistDistHistogram(const std::string astem, 
                       const std::string bstem, int sample_size);
     ~DistDistHistogram();
     void plot();
     virtual double score_ub(Box box1, Box box2);
     virtual double score_lb(Box box1, Box box2);
     virtual float pvalue(float distance);
};

class DistDistExp : public DistDist {
     double lambda;
 public:
     DistDistExp(double lambda);
     virtual double score_ub(Box box1, Box box2);
     virtual double score_lb(Box box1, Box box2);
     virtual float pvalue(float distance);
};

// float point_distance(Point a, Point b);
float box_min_distance(Box box1, Box box2);
float box_max_distance(Box box1, Box box2);
float box_mean_distance(Box box1, Box box2);

#endif
