#include <sysexits.h>
#include <string>
#include <sstream>
#include <vlcutils/progress.h>
#include "ptopk.h"
#include "index.h"
#include "score.h"
#include "join.h" 

static void usage(FILE *stream)
{
     fprintf(stream ,"Usage %s FILENAME\n", 
                  program_name);
     if (stream == stderr)
          fprintf(stream, "Try `%s -h` for more information.\n", program_name);
}

static void help(void)
{
     usage(stdout);
     printf("\n"
"      -h            Display this help.\n"
          );
}

static std::string filename("");

static void parse_options(int argc, char *argv[])
{
     int opt;

     while ((opt = getopt(argc, argv, "h")) != -1)
          switch (opt) {
          case 'h': help(); exit(EX_OK);
          default: usage(stderr); exit(EX_USAGE);
          }
     if (argc == optind + 1) {
          filename = argv[optind];
     } else {
          usage(stderr);
          exit(EX_USAGE);
     }
         
}

int main(int argc, char *argv[])
{
     double lambda = 1 / 223.0;

     set_program_name(argv[0]);
     parse_options(argc, argv);

     ReadableIndex a(filename);
     a.info();
     return EX_OK;
}
