import java.io.*;
import java.util.*;

import spatialindex.spatialindex.*;
import spatialindex.storagemanager.*;
import spatialindex.rtree.*;

class loadrtree {


     public static void main(String args[])
          throws IOException
          {

          PropertySet ps = new PropertySet();
          ps.setProperty("Overwrite", new Boolean(true));
          ps.setProperty("FileName", args[0]);
//          int boxSize = 512;
//          if (args.length == 3)
          int pageSize = Integer.parseInt(args[2]);
          ps.setProperty("PageSize", new Integer(pageSize));
          IStorageManager diskfile = new DiskStorageManager(ps);
          IBuffer file = new RandomEvictionsBuffer(diskfile, 10, false);
          PropertySet ps2 = new PropertySet();
          ps2.setProperty("FillFactor", new Double(0.7));
          ps2.setProperty("IndexCapacity", new Integer(pageSize/24));
          ps2.setProperty("LeafCapacity", new Integer(pageSize/12));
          ps2.setProperty("Dimension", new Integer(3));
          ISpatialIndex tree = new RTree(ps2, file);
          
          LineNumberReader lr = null;
          try {
               lr = new LineNumberReader(new FileReader(args[1]));
          }
          catch (FileNotFoundException e) {
               System.err.println("Cannot open data file " + args[1] + ".");
               System.exit(-1);
          }
          String line = lr.readLine();
          double[] f = new double[3];
          int id = 0;
          while (line != null) {
               StringTokenizer st = new StringTokenizer(line);
               double v = new Double(st.nextToken()).doubleValue();
               double x = new Double(st.nextToken()).doubleValue();
               double y = new Double(st.nextToken()).doubleValue();
               f[0] = v;
               f[1] = x;
               f[2] = y;
               Point p = new Point(f);
               tree.insertData(null, p, id);
               id++;
               if (id % 1000 == 0)
                    System.out.println(id);
               line = lr.readLine();
          }
          tree.flush();
     }
}
