#include "ptopk.h"
#include "score.h"
#include "join.h"

void nlj(Box abox, Box bbox, double lambda, Results *results)
{
//     printf("nlj(%d, %d)\n", abox.npoints, bbox.npoints);
     Score_1D score(lambda);
     for (int i = 0; i < abox.npoints; i++) {
          Point apoint = abox.get_point(i);
          for (int j = 0; j < bbox.npoints; j++) {
               Point bpoint = bbox.get_point(j);
               double s = score(apoint, bpoint);
               if (s > results->threshold)
                    results->insert(Result(abox.object_id(), apoint, 
                                           bbox.object_id(), bpoint, s));
          }
     }
}
