#!/bin/bash
set -e

if [ $# != 3 ]; then
	exec 1>&2
	echo Usage: `basename "$0"` INPUT-STEM OUTPUT-STEM FACTOR
	exit 1
fi

input_stem="$1"
output_stem="$2"
factor="$3"

rm -rf "$output_stem"
cp -a "$input_stem" "$output_stem"

while [ $factor -gt 1 ]; do
    for a in objects boxes points; do
	cat "$input_stem/$a" >> "$output_stem/$a"
    done
    factor=$(($factor - 1))
done
