#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <sysexits.h>
#include <vlcutils/error.h>
#include "ddist.h"
#include "histogram.h"

int main(int argc, char *argv[])
{
     set_program_name(argv[0]);
     if (argc != 4 && argc != 5) {
          fprintf(stderr, "Usage: %s A-STEM B-STEM SAMPLE_SIZE [NBINS]\n",
                  program_name);
          exit(EX_USAGE);
     }
     char *astem = argv[1];
     char *bstem = argv[2];
     int sample_size = atoi(argv[3]);
     if (sample_size <= 0)
          fatal_error("Sample size must be positive: %s", argv[3]);
     int nbins = 100;
     if (argc == 5) {
          nbins = atoi(argv[4]);
          if (nbins <= 0)
               fatal_error("The number of bins must be positive: %s", argv[4]);
     }

     srandom(time(NULL));

     DistDistHistogram dd(astem, bstem, sample_size);
     plot_pdf(dd.h);

     return EX_OK;
}
