#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <sysexits.h>
#include <vlcutils/error.h>
#include "ddist.h"
#include "histogram.h"

int main(int argc, char *argv[])
{
     set_program_name(argv[0]);
     if (argc != 2 && argc != 3) {
          fprintf(stderr, "Usage: %s LAMBDA\n", program_name);
          fprintf(stderr, "   or: %s A-STEM B-STEM\n", program_name);
          exit(EX_USAGE);
     }
     DistDist *ddist;
     if (argc == 2) {
          double lambda = atof(argv[1]);
          ddist = new DistDistExp(lambda);
     } else {
          char *astem = argv[1];
          char *bstem = argv[2];
          ddist = new DistDistHistogram(astem, bstem, 1000);
     }

     for (int i = 0; i < 700; i++) {
          printf("%d %f\n", i, ddist->pvalue(i));
     }
     delete ddist;
     return EX_OK;
}
