#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <sysexits.h>
#include <vlcutils/error.h>
#include "mmapping.h"
#include "ptopk.h"
#include "ddist.h"
#include "sdist.h"
#include "histogram.h"

int main(int argc, char *argv[])
{
     set_program_name(argv[0]);
     if (argc != 3) {
          fprintf(stderr, "Usage: %s STEM-A STEM-B\n",
                  program_name);
          exit(EX_USAGE);
     }
     char *stema = argv[1];
     char *stemb = argv[2];

     Mmapping<struct box> aboxes(stema, ".boxes");
     Mmapping<struct box> bboxes(stemb, ".boxes");
     srandom(time(NULL));
     const struct box *boxa = &aboxes.data[193]; // random() % aboxes.size];
     const struct box *boxb = &bboxes.data[878]; //random() % bboxes.size];
     fprintf(stderr, "(%f, %f)--(%f, %f); (%f, %f)--(%f, %f)\n", boxa->x1_min,
             boxa->x2_min, boxa->x1_max, boxa->x2_max, boxb->x1_min,
             boxb->x2_min, boxb->x1_max, boxb->x2_max);
     struct distprofile *dp = make_distprofile(boxa, boxb);
     plot_pdf(dp->cdf);
     free_distprofile(dp);
     DistDistHistogram distdist(stema, stemb, 5000);
     struct scoredist *sd = make_scoredist(&distdist, boxa, boxb);
     plot_pdf(sd->cdf);
     return EX_OK;
}
