% Precompute EVD parameters for various beta distributions

alpha = linspace(1, 6, 20);
beta = linspace(1, 6, 20);
n = 5000; % Number of points to sample from beta distribution

gevparams = zeros((size(alpha,2) - 1)*(size(beta,2) - 1), 5);
f = fopen('evdparams.dat', 'w');
for i = 2:size(alpha,2)
    for j = 2:size(beta,2)
        samples = betarnd(alpha(i), beta(j), n, 1);
        k = (i - 2) * (size(beta, 2) - 1) + j - 1;
        gevparams(k, 1) = alpha(i);
        gevparams(k, 2) = beta(j);
        gevparams(k, 3:5) = gevfit(samples);
        if (gevparams(k, 3) >= 0)
            error('shape (k) should be negative');
        end
        fprintf(f, '%f\t%f\t%f\t%f\t%f\n', gevparams(k, 1), ...
            gevparams(k, 2), gevparams(k, 3), gevparams(k, 4), ...
            gevparams(k, 5));
    end
end
fclose(f);
