#!/bin/bash
#
# Extract the points from a pmask.

set -e

imagefn="$1"
stem="$2"
page_size="$3"

[ -z "$page_size" ] && page_size=4096

box_size=$(($page_size / 12))

./imagetuples.py "$imagefn" > tmp.$$.tuples
java -cp spatialindex.jar:. loadrtree tmp.$$.tree tmp.$$.tuples $page_size
java -cp spatialindex.jar:. traversetree tmp.$$.tree > tmp.$$.toconvert
./convertrtree "$stem" $box_size < tmp.$$.toconvert
rm tmp.$$.{tuples,toconvert} tmp.$$.tree.{dat,idx}
