#ifndef SDIST_H
#define SDIST_H

struct histogram;

struct distprofile {
     struct histogram *cdf;
};

struct distprofile *make_distprofile(Box box1, Box box2);
void free_distprofile(struct distprofile *dp);

struct scoredist {
     struct histogram *cdf;
};

class DistDist;

struct scoredist *make_scoredist(DistDist *distdist, Box box1, Box box2);
struct scoredist *make_scoredist_exp(double lambda, Box box1, Box box2);

void free_scoredist(struct scoredist *sd);

float scoredist_pexceed(const struct scoredist *sd, float threshold);

class EVD {
public:
     float k, sigma, mu;
     EVD() {}
     EVD(float k, float sigma, float mu);
     float pexceed(float threshold);
};

class ScoreDistBeta {
 protected:
     double alpha, beta;
     void lookup_evdparams(double alpha, double beta);
 public:
     EVD evd;
     ScoreDistBeta(double k, double sigma, double mu);
     ScoreDistBeta(DistDist *distDist, Box box1, Box box2);
     ~ScoreDistBeta();
     float pexceed(float threshold);
};

#endif
