#include <math.h>
#include "ptopk.h"
#include "index.h"
#include "join.h"

class CountReporter : public Results {
public:
     long results;
     CountReporter(double threshold) : Results(threshold), results(0) {}
     virtual bool insert(Result r) {
          results++;
     }
};

int main()
{
     ReadableIndex a("../experiments/7ca-33-x209y466-4096");
     ReadableIndex b("../experiments/7ca-33-x362y289-4096");
     CountReporter reporter(3e-5);
//     Box abox = a.get_box(0);
//     Box bbox = b.get_box(0);
//     printf("%f\n", score_ub(abox, bbox));
     double lambda = 1/223.0;

     planesweep(a.get_box(0), b.get_box(0), lambda, &reporter);
     printf("Plane sweep returned %d results.\n", reporter.results);
     reporter.results = 0;
     
     nlj(a.get_box(0), b.get_box(0), lambda, &reporter);
     printf("NLJ returned %d results.\n", reporter.results);
     reporter.results = 0;

     subboxes(a.get_box(0), b.get_box(0), lambda, &reporter);
     printf("Subboxes returned %d results.\n", reporter.results);

     return 0;
}
