import java.io.*;
import java.util.*;

import spatialindex.spatialindex.*;
import spatialindex.storagemanager.*;
import spatialindex.rtree.*;

class traversetree {
     public static void main(String args[])
          throws IOException {

          PropertySet ps = new PropertySet();
          ps.setProperty("FileName", args[0]);
          IStorageManager diskfile = new DiskStorageManager(ps);
          IBuffer file = new RandomEvictionsBuffer(diskfile, 10, false);
          PropertySet ps2 = new PropertySet();
          ps2.setProperty("IndexIdentifier", new Integer(1));
          ISpatialIndex tree = new RTree(ps2, file);
          
          int m_dimension = 3;
          double m_pLow[] = new double[m_dimension];
          double m_pHigh[] = new double[m_dimension];
          for (int cDim = 0; cDim < m_dimension; cDim++) {
               m_pLow[cDim] = Double.NEGATIVE_INFINITY;
               m_pHigh[cDim] = Double.POSITIVE_INFINITY;
          }
          Region m_infiniteRegion = new Region(m_pLow, m_pHigh);          
          
          tree.intersectionQuery(m_infiniteRegion, new MyVisitor());
     }
     static class MyVisitor implements IVisitor
     {
          public void visitNode(final INode n) {
               if (n.isLeaf()) {
                    System.out.println(n.getChildrenCount());
                    for (int i = 0; i < n.getChildrenCount(); i++) {
                         Region p = (Region)n.getChildShape(i);
                         double c[] = p.getCenter();
                         System.out.println(c[0] + " " + c[1] + " " + c[2]);
                    }
               }
          }
          public void visitData(final IData d) {
//               System.out.println(d.getIdentifier());
          }
     }
}
