#include <stdio.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include "error.h"
#include "readline.h"

int fcount(FILE *f, int c)
{
     int fd, count;
     off_t length;
     char *contents, *pos;
     off_t offset;

     fd = fileno(f);
     if (fd == -1) fatal_perror("fileno");
     length = lseek(fd, 0, SEEK_END);
     if (length == (off_t)-1) fatal_perror("lseek");
     contents = mmap(NULL, length, PROT_READ, MAP_SHARED, fd, 0);
     if (contents == MAP_FAILED) fatal_perror("mmap");
     count = 0;
     offset = 0;
     while (offset < length) {
          pos = memchr(contents + offset, c, length - offset);
          if (pos) {
               count++;
               offset = pos - contents + 1;
          } else
               break;
     }
     if (munmap(contents, length) == -1) fatal_perror("munmap");
     return count;
}
